using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using Exferia_EntityFramework;
using Exferia_General;
using Exferia_KairosPRO._1_Modelos;
using Exferia_KairosPRO.General;
using Exferia_KairosPRO_EF;
using System.Collections.Generic;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_KairosPRO._4_Vistas.Listados
{
    public class ABS_Listado_KRS_SolicitudesAusenciasProgramadas_P_SolicitudesAusenciasProgramadas_Supervisor : ABS_Listado
    {
        private Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();
       
        //Constructor
        public ABS_Listado_KRS_SolicitudesAusenciasProgramadas_P_SolicitudesAusenciasProgramadas_Supervisor()
        {
            Rellenar_Columnas();
        }

        private void Rellenar_Columnas()
        {
            //id
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_KRS_SolicitudesAusenciasProgramadas_Listado_Modelo.id), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_KRS_SolicitudesAusenciasProgramadas_Listado_Modelo.id), "id", G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, false, false, "", null));

            //fechaSolicitud
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_KRS_SolicitudesAusenciasProgramadas_Listado_Modelo.fechaSolicitud), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_KRS_SolicitudesAusenciasProgramadas_Listado_Modelo.fechaSolicitud), "Fecha de la solicitud", G_ENUM_TIPOSDATOS.DATETIME, false, 100, true, false, true, false, "", null));

            //EMPLEADO #######################################################
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_EMPLEADO = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_KRS_SolicitudesAusenciasProgramadas_Listado_Modelo.idEmpleado), nameof(KRS_Empleados), nameof(KRS_Empleados.id), nameof(KRS_Empleados.codigoValidacion), nameof(KRS_Empleados.nombre), nameof(KRS_Empleados.fechaBorrado),Variables.G_STR_LIBRERIA_KAIROSPRO,Variables.G_STR_LIBRERIA_DATOSKAIROSPRO,Variables.G_STR_LIBRERIA_DATOSKAIROSPRO_PROCEDIMIENTO_BUSCARDATOSFILTROSRELACIONADOS,Variables.G_STR_LIBRERIA_KAIROSPRO);
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_KRS_SolicitudesAusenciasProgramadas_Listado_Modelo.Empleado), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_KRS_SolicitudesAusenciasProgramadas_Listado_Modelo.Empleado), "Empleado", G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, true, true, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_EMPLEADO));

            //AUSENCIAPROGRAMADATIPO #######################################################
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_AUSENCIAPROGRAMADATIPO = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_KRS_SolicitudesAusenciasProgramadas_Listado_Modelo.idAusenciaProgramadaTipo), nameof(KRS_AusenciasProgramadasTipos), nameof(KRS_AusenciasProgramadasTipos.id), nameof(KRS_AusenciasProgramadasTipos.codigo), nameof(KRS_AusenciasProgramadasTipos.descripcion), nameof(KRS_AusenciasProgramadasTipos.fechaBorrado), Variables.G_STR_LIBRERIA_KAIROSPRO, Variables.G_STR_LIBRERIA_DATOSKAIROSPRO, Variables.G_STR_LIBRERIA_DATOSKAIROSPRO_PROCEDIMIENTO_BUSCARDATOSFILTROSRELACIONADOS, Variables.G_STR_LIBRERIA_KAIROSPRO);
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_KRS_SolicitudesAusenciasProgramadas_Listado_Modelo.AusenciasProgramadasTipos), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_KRS_SolicitudesAusenciasProgramadas_Listado_Modelo.AusenciasProgramadasTipos), "Tipo Ausencia", G_ENUM_TIPOSDATOS.RELACIONADA, false, 120, false, true, true, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_AUSENCIAPROGRAMADATIPO));

            //fechaDesde
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_KRS_SolicitudesAusenciasProgramadas_Listado_Modelo.fechaDesde), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_KRS_SolicitudesAusenciasProgramadas_Listado_Modelo.fechaDesde), "Fecha desde", G_ENUM_TIPOSDATOS.DATETIME, false, 100, true, false, true, false, "", null));

            //fechaHasta
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_KRS_SolicitudesAusenciasProgramadas_Listado_Modelo.fechaHasta), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_KRS_SolicitudesAusenciasProgramadas_Listado_Modelo.fechaHasta), "Fecha hasta", G_ENUM_TIPOSDATOS.DATETIME, false, 100, true, false, true, false, "", null));

            //ESTADO #######################################################################
            INTERNO_Filtro_Opciones_Modelo mdl_INTERNO_Filtro_Opciones_Modelo_ESTADO = new INTERNO_Filtro_Opciones_Modelo();
            mdl_INTERNO_Filtro_Opciones_Modelo_ESTADO.MULTISELECCION = true;
            mdl_INTERNO_Filtro_Opciones_Modelo_ESTADO.LISTADO = new List<INTERNO_Filtro_Opciones_Listado_Modelo>();
            mdl_INTERNO_Filtro_Opciones_Modelo_ESTADO.LISTADO.Add(new INTERNO_Filtro_Opciones_Listado_Modelo(Variables_KairosPRO.G_MDL_ESTADOSOLICITUD_PENDIENTE.Descripcion, Variables_KairosPRO.G_MDL_ESTADOSOLICITUD_PENDIENTE.Descripcion));
            mdl_INTERNO_Filtro_Opciones_Modelo_ESTADO.LISTADO.Add(new INTERNO_Filtro_Opciones_Listado_Modelo(Variables_KairosPRO.G_MDL_ESTADOSOLICITUD_ENCURSO.Descripcion, Variables_KairosPRO.G_MDL_ESTADOSOLICITUD_ENCURSO.Descripcion));
            mdl_INTERNO_Filtro_Opciones_Modelo_ESTADO.LISTADO.Add(new INTERNO_Filtro_Opciones_Listado_Modelo(Variables_KairosPRO.G_MDL_ESTADOSOLICITUD_CANCELADO.Descripcion, Variables_KairosPRO.G_MDL_ESTADOSOLICITUD_CANCELADO.Descripcion));
            mdl_INTERNO_Filtro_Opciones_Modelo_ESTADO.LISTADO.Add(new INTERNO_Filtro_Opciones_Listado_Modelo(Variables_KairosPRO.G_MDL_ESTADOSOLICITUD_ACEPTADO.Descripcion, Variables_KairosPRO.G_MDL_ESTADOSOLICITUD_ACEPTADO.Descripcion));
            mdl_INTERNO_Filtro_Opciones_Modelo_ESTADO.TIPO = 1;
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_KRS_SolicitudesAusenciasProgramadas_Listado_Modelo.Estado_Texto), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_KRS_SolicitudesAusenciasProgramadas_Listado_Modelo.Estado_Texto), "Estado", G_ENUM_TIPOSDATOS.OPCIONES, false, 80, true, false, true, false, "", null, false, mdl_INTERNO_Filtro_Opciones_Modelo_ESTADO));

            //observaciones
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_KRS_SolicitudesAusenciasProgramadas_Listado_Modelo.observaciones), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_KRS_SolicitudesAusenciasProgramadas_Listado_Modelo.observaciones), "Observaciones", G_ENUM_TIPOSDATOS.TEXT, false, 150, true, false, true, false, "", null));

            //Boton_Adjunto
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_KRS_SolicitudesAusenciasProgramadas_Listado_Modelo.Boton_Adjunto), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_KRS_SolicitudesAusenciasProgramadas_Listado_Modelo.Boton_Adjunto), "Adjuntos", G_ENUM_TIPOSDATOS.BOTON, false, 100, false, false, true, false, "", null));

            //Boton_Cancelar
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_KRS_SolicitudesAusenciasProgramadas_Listado_Modelo.Boton_Cancelar), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_KRS_SolicitudesAusenciasProgramadas_Listado_Modelo.Boton_Cancelar), "", G_ENUM_TIPOSDATOS.BOTON, false, 100, false, false, true, false, "", null));

            //Boton_Aceptar
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_KRS_SolicitudesAusenciasProgramadas_Listado_Modelo.Boton_Aceptar), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_KRS_SolicitudesAusenciasProgramadas_Listado_Modelo.Boton_Aceptar), "", G_ENUM_TIPOSDATOS.BOTON, false, 100, false, false, true, false, "", null));

            //Boton_VerSolicitud
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_KRS_SolicitudesAusenciasProgramadas_Listado_Modelo.Boton_VerSolicitud), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_KRS_SolicitudesAusenciasProgramadas_Listado_Modelo.Boton_VerSolicitud), "Ver", G_ENUM_TIPOSDATOS.BOTON, false, 100, false, true, true, false, "", null));

        }

        public override List<dynamic> LISTADO()
        {
            return Registros;
        }

        public override INTERNO_OpcionesDetalle_Modelo DATOS_OPCION()
        {
            return Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_KRS_SOLICITUDESAUSENCIASPROGRAMADAS);
        }

        public override string NOMBRELISTADO_ALMACENARCONFIGURACION()
        {
            return Variables.G_STR_OPCION_KRS_SOLICITUDESAUSENCIASPROGRAMADAS + "_Supervidor";
        }

        public override Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> LISTADO_COLUMNAS()
        {
            return g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo;
        }

        public override string ORDENACION_NOMBRECOLUMNA_PORDEFECTO()
        {
            return nameof(INTERNO_KRS_SolicitudesAusenciasProgramadas_Listado_Modelo.fechaSolicitud);
        }

        public override string ORDENACION_TIPO_PORDEFECTO()
        {
            return "0";
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_1()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_2()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_3()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_4()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_5()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_6()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_7()
        {
            return null;
        }

        public override List<INTERNO_ArbolSecundarioSeleccion_Modelo> LISTADO_ARBOLSECUNDARIOSELECCION()
        {
            return null;
        }

        public override List<INTERNO_Listado_Paginado_Filtro_Modelo> FILTRADO_PARAPAGINADO()
        {
            return null;
        }

        public override List<string> LISTADOCAMPOS_ENVIAR_A_MANTENIMIENTO()
        {
            return null;
        }
    }
}
